diff --git a/rsvg-marker.c b/rsvg-marker.c
index 658d699..bcca6d7 100644
--- a/rsvg-marker.c
+++ b/rsvg-marker.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-marker.c: Marker loading and rendering
 
@@ -22,6 +23,8 @@
    Authors: Caleb Moore <c.moore@student.unsw.edu.au>
 */
 
+#include "config.h"
+
 #include "rsvg-marker.h"
 #include "rsvg-private.h"
 #include "rsvg-styles.h"
@@ -31,6 +34,7 @@
 #include "rsvg-filter.h"
 #include "rsvg-mask.h"
 #include "rsvg-image.h"
+#include "rsvg-path.h"
 
 #include <string.h>
 #include <math.h>
@@ -83,45 +87,55 @@ rsvg_new_marker (void)
 {
     RsvgMarker *marker;
     marker = g_new (RsvgMarker, 1);
-    _rsvg_node_init (&marker->super);
+    _rsvg_node_init (&marker->super, RSVG_NODE_TYPE_MARKER);
     marker->orient = 0;
     marker->orientAuto = FALSE;
     marker->preserve_aspect_ratio = RSVG_ASPECT_RATIO_XMID_YMID;
     marker->refX = marker->refY = _rsvg_css_parse_length ("0");
-    marker->width = marker->height = _rsvg_css_parse_length ("1");
+    marker->width = marker->height = _rsvg_css_parse_length ("3");
     marker->bbox = TRUE;
     marker->vbox.active = FALSE;
     marker->super.set_atts = rsvg_node_marker_set_atts;
     return &marker->super;
 }
 
-void
-rsvg_marker_render (RsvgMarker * self, gdouble x, gdouble y, gdouble orient, gdouble linewidth,
+static void
+rsvg_marker_render (const char * marker_name, gdouble xpos, gdouble ypos, gdouble orient, gdouble linewidth,
                     RsvgDrawingCtx * ctx)
 {
-    gdouble affine[6];
-    gdouble taffine[6];
+    RsvgMarker *self;
+    cairo_matrix_t affine, taffine;
     unsigned int i;
     gdouble rotation;
-    RsvgState *state = rsvg_state_current (ctx);
+    RsvgState *state = rsvg_current_state (ctx);
+
+    if (marker_name == NULL)
+        return; /* to avoid the caller having to check for nonexistent markers on every call */
 
-    _rsvg_affine_translate (taffine, x, y);
-    _rsvg_affine_multiply (affine, taffine, state->affine);
+    self = (RsvgMarker *) rsvg_acquire_node (ctx, marker_name);
+    if (self == NULL || RSVG_NODE_TYPE (&self->super) != RSVG_NODE_TYPE_MARKER)
+      {
+        rsvg_release_node (ctx, &self->super);
+        return;
+      }
+
+    cairo_matrix_init_translate (&taffine, xpos, ypos);
+    cairo_matrix_multiply (&affine, &taffine, &state->affine);
 
     if (self->orientAuto)
-        rotation = orient * 180. / M_PI;
+        rotation = orient;
     else
-        rotation = self->orient;
-    _rsvg_affine_rotate (taffine, rotation);
-    _rsvg_affine_multiply (affine, taffine, affine);
+        rotation = self->orient * M_PI / 180.;
+
+    cairo_matrix_init_rotate (&taffine, rotation);
+    cairo_matrix_multiply (&affine, &taffine, &affine);
 
     if (self->bbox) {
-        _rsvg_affine_scale (taffine, linewidth, linewidth);
-        _rsvg_affine_multiply (affine, taffine, affine);
+        cairo_matrix_init_scale (&taffine, linewidth, linewidth);
+        cairo_matrix_multiply (&affine, &taffine, &affine);
     }
 
     if (self->vbox.active) {
-
         double w, h, x, y;
         w = _rsvg_css_normalize_length (&self->width, ctx, 'h');
         h = _rsvg_css_normalize_length (&self->height, ctx, 'v');
@@ -129,48 +143,42 @@ rsvg_marker_render (RsvgMarker * self, gdouble x, gdouble y, gdouble orient, gdo
         y = 0;
 
         rsvg_preserve_aspect_ratio (self->preserve_aspect_ratio,
-                                    self->vbox.w, self->vbox.h, &w, &h, &x, &y);
-
-        x = -self->vbox.x * w / self->vbox.w;
-        y = -self->vbox.y * h / self->vbox.h;
-
-        taffine[0] = w / self->vbox.w;
-        taffine[1] = 0.;
-        taffine[2] = 0.;
-        taffine[3] = h / self->vbox.h;
-        taffine[4] = x;
-        taffine[5] = y;
-        _rsvg_affine_multiply (affine, taffine, affine);
-        _rsvg_push_view_box (ctx, self->vbox.w, self->vbox.h);
+                                    self->vbox.rect.width,
+                                    self->vbox.rect.height,
+                                    &w, &h, &x, &y);
+
+        cairo_matrix_init_scale (&taffine, w / self->vbox.rect.width, h / self->vbox.rect.height);
+        cairo_matrix_multiply (&affine, &taffine, &affine);
+
+        _rsvg_push_view_box (ctx, self->vbox.rect.width, self->vbox.rect.height);
     }
-    _rsvg_affine_translate (taffine,
-                            -_rsvg_css_normalize_length (&self->refX, ctx, 'h'),
-                            -_rsvg_css_normalize_length (&self->refY, ctx, 'v'));
-    _rsvg_affine_multiply (affine, taffine, affine);
 
+    cairo_matrix_init_translate (&taffine,
+                                 -_rsvg_css_normalize_length (&self->refX, ctx, 'h'),
+                                 -_rsvg_css_normalize_length (&self->refY, ctx, 'v'));
+    cairo_matrix_multiply (&affine, &taffine, &affine);
 
     rsvg_state_push (ctx);
-    state = rsvg_state_current (ctx);
+    state = rsvg_current_state (ctx);
 
-    rsvg_state_finalize (state);
-    rsvg_state_init (state);
+    rsvg_state_reinit (state);
 
     rsvg_state_reconstruct (state, &self->super);
 
-    for (i = 0; i < 6; i++)
-        state->affine[i] = affine[i];
+    state->affine = affine;
 
     rsvg_push_discrete_layer (ctx);
 
-    state = rsvg_state_current (ctx);
+    state = rsvg_current_state (ctx);
 
     if (!state->overflow) {
-	if (self->vbox.active)
-	    rsvg_add_clipping_rect (ctx, self->vbox.x, self->vbox.y, self->vbox.w, self->vbox.h);
-	else
-	    rsvg_add_clipping_rect (ctx, 0, 0,
-				    _rsvg_css_normalize_length (&self->width, ctx, 'h'),
-				    _rsvg_css_normalize_length (&self->height, ctx, 'v'));
+        if (self->vbox.active)
+            rsvg_add_clipping_rect (ctx, self->vbox.rect.x, self->vbox.rect.y,
+                                    self->vbox.rect.width, self->vbox.rect.height);
+        else
+            rsvg_add_clipping_rect (ctx, 0, 0,
+                                    _rsvg_css_normalize_length (&self->width, ctx, 'h'),
+                                    _rsvg_css_normalize_length (&self->height, ctx, 'v'));
     }
 
     for (i = 0; i < self->super.children->len; i++) {
@@ -185,123 +193,453 @@ rsvg_marker_render (RsvgMarker * self, gdouble x, gdouble y, gdouble orient, gdo
     rsvg_state_pop (ctx);
     if (self->vbox.active)
         _rsvg_pop_view_box (ctx);
+
+    rsvg_release_node (ctx, (RsvgNode *) self);
 }
 
-RsvgNode *
-rsvg_marker_parse (const RsvgDefs * defs, const char *str)
+typedef struct {
+    gboolean is_degenerate; /* If true, only (p1x, p1y) are valid.  If false, all are valid */
+    double p1x, p1y;
+    double p2x, p2y;
+    double p3x, p3y;
+    double p4x, p4y;
+} Segment;
+
+typedef enum {
+    SEGMENT_START,
+    SEGMENT_END,
+} SegmentState;
+
+/* This converts a cairo_path_t into a list of curveto-like segments.  Each segment can be:
+ *
+ * 1. segment->is_degenerate = TRUE => the segment is actually a single point (segment->p1x, segment->p1y)
+ *
+ * 2. segment->is_degenerate = FALSE => either a lineto or a curveto (or the effective lineto that results from a closepath).
+ *    We have the following points:
+ *       P1 = (p1x, p1y)
+ *       P2 = (p2x, p2y)
+ *       P3 = (p3x, p3y)
+ *       P4 = (p4x, p4y)
+ *
+ *    The start and end points are P1 and P4, respectively.
+ *    The tangent at the start point is given by the vector (P2 - P1).
+ *    The tangent at the end point is given by the vector (P4 - P3).
+ *    The tangents also work if the segment refers to a lineto (they will both just point in the same direction).
+ */
+
+#define EPSILON 1e-10
+#define DOUBLE_EQUALS(a, b) (fabs ((a) - (b)) < EPSILON)
+
+static void
+path_to_segments (const cairo_path_t *path,
+                  Segment **out_segments,
+                  int *num_segments)
 {
-    char *name;
+    int i;
+    double last_x, last_y;
+    double cur_x, cur_y;
+    double subpath_start_x, subpath_start_y;
+    int max_segments;
+    int segment_num;
+    Segment *segments;
+    SegmentState state;
+
+    max_segments = path->num_data; /* We'll generate maximum this many segments */
+    segments = g_new (Segment, max_segments);
+    *out_segments = segments;
+
+    last_x = last_y = cur_x = cur_y = subpath_start_x = subpath_start_y = 0.0;
+
+    segment_num = -1;
+    state = SEGMENT_END;
+
+    for (i = 0; i < path->num_data; i += path->data[i].header.length) {
+        last_x = cur_x;
+        last_y = cur_y;
+
+        switch (path->data[i].header.type) {
+        case CAIRO_PATH_MOVE_TO:
+            segment_num++;
+            g_assert (segment_num < max_segments);
+
+            g_assert (i + 1 < path->num_data);
+            cur_x = path->data[i + 1].point.x;
+            cur_y = path->data[i + 1].point.y;
+
+            subpath_start_x = cur_x;
+            subpath_start_y = cur_y;
+
+            segments[segment_num].is_degenerate = TRUE;
+
+            segments[segment_num].p1x = cur_x;
+            segments[segment_num].p1y = cur_y;
+
+            state = SEGMENT_START;
+
+            break;
+
+        case CAIRO_PATH_LINE_TO:
+            g_assert (i + 1 < path->num_data);
+            cur_x = path->data[i + 1].point.x;
+            cur_y = path->data[i + 1].point.y;
+
+            if (state == SEGMENT_START) {
+                segments[segment_num].is_degenerate = FALSE;
+                state = SEGMENT_END;
+            } else {
+                segment_num++;
+                g_assert (segment_num < max_segments);
+
+                segments[segment_num].is_degenerate = FALSE;
+
+                segments[segment_num].p1x = last_x;
+                segments[segment_num].p1y = last_y;
+            }
+
+            segments[segment_num].p2x = cur_x;
+            segments[segment_num].p2y = cur_y;
 
-    name = rsvg_get_url_string (str);
-    if (name) {
-        RsvgNode *val;
-        val = rsvg_defs_lookup (defs, name);
-        g_free (name);
+            segments[segment_num].p3x = last_x;
+            segments[segment_num].p3y = last_y;
 
-        if (val && (!strcmp (val->type->str, "marker")))
-            return val;
+            segments[segment_num].p4x = cur_x;
+            segments[segment_num].p4y = cur_y;
+
+            break;
+
+        case CAIRO_PATH_CURVE_TO:
+            g_assert (i + 3 < path->num_data);
+            cur_x = path->data[i + 3].point.x;
+            cur_y = path->data[i + 3].point.y;
+
+            if (state == SEGMENT_START) {
+                segments[segment_num].is_degenerate = FALSE;
+                state = SEGMENT_END;
+            } else {
+                segment_num++;
+                g_assert (segment_num < max_segments);
+
+                segments[segment_num].is_degenerate = FALSE;
+
+                segments[segment_num].p1x = last_x;
+                segments[segment_num].p1y = last_y;
+            }
+
+            segments[segment_num].p2x = path->data[i + 1].point.x;
+            segments[segment_num].p2y = path->data[i + 1].point.y;
+
+            segments[segment_num].p3x = path->data[i + 2].point.x;
+            segments[segment_num].p3y = path->data[i + 2].point.y;
+
+            segments[segment_num].p4x = cur_x;
+            segments[segment_num].p4y = cur_y;
+
+            /* Fix the tangents for when the middle control points coincide with their respective endpoints */
+
+            if (DOUBLE_EQUALS (segments[segment_num].p2x, segments[segment_num].p1x)
+                && DOUBLE_EQUALS (segments[segment_num].p2y, segments[segment_num].p1y)) {
+                segments[segment_num].p2x = segments[segment_num].p3x;
+                segments[segment_num].p2y = segments[segment_num].p3y;
+            }
+
+            if (DOUBLE_EQUALS (segments[segment_num].p3x, segments[segment_num].p4x)
+                && DOUBLE_EQUALS (segments[segment_num].p3y, segments[segment_num].p4y)) {
+                segments[segment_num].p3x = segments[segment_num].p2x;
+                segments[segment_num].p3y = segments[segment_num].p2y;
+            }
+
+            break;
+
+        case CAIRO_PATH_CLOSE_PATH:
+            cur_x = subpath_start_x;
+            cur_y = subpath_start_y;
+
+            if (state == SEGMENT_START) {
+                segments[segment_num].is_degenerate = FALSE;
+
+                segments[segment_num].p2x = cur_x;
+                segments[segment_num].p2y = cur_y;
+
+                segments[segment_num].p3x = last_x;
+                segments[segment_num].p3y = last_y;
+
+                segments[segment_num].p4x = cur_x;
+                segments[segment_num].p4y = cur_y;
+
+                state = SEGMENT_END;
+            } else {
+                /* nothing; closepath after moveto (or a single lone closepath) does nothing */
+            }
+
+            break;
+
+        default:
+            g_assert_not_reached ();
+        }
     }
-    return NULL;
+
+    *num_segments = segment_num + 1;
+    g_assert (*num_segments <= max_segments);
 }
 
+static gboolean
+points_equal (double x1, double y1, double x2, double y2)
+{
+    return DOUBLE_EQUALS (x1, x2) && DOUBLE_EQUALS (y1, y2);
+}
+
+/* A segment is zero length if it is degenerate, or if all four control points
+ * coincide (the first and last control points may coincide, but the others may
+ * define a loop - thus nonzero length)
+ */
+static gboolean
+is_zero_length_segment (Segment *segment)
+{
+    double p1x, p1y;
+    double p2x, p2y;
+    double p3x, p3y;
+    double p4x, p4y;
+
+    if (segment->is_degenerate)
+        return TRUE;
+
+    p1x = segment->p1x;
+    p1y = segment->p1y;
+
+    p2x = segment->p2x;
+    p2y = segment->p2y;
+
+    p3x = segment->p3x;
+    p3y = segment->p3y;
+
+    p4x = segment->p4x;
+    p4y = segment->p4y;
+
+    return (points_equal (p1x, p1y, p2x, p2y)
+            && points_equal (p1x, p1y, p3x, p3y)
+            && points_equal (p1x, p1y, p4x, p4y));
+}
+
+/* The SVG spec 1.1 says http://www.w3.org/TR/SVG/implnote.html#PathElementImplementationNotes
+ *
+ * Certain line-capping and line-joining situations and markers
+ * require that a path segment have directionality at its start and
+ * end points. Zero-length path segments have no directionality. In
+ * these cases, the following algorithm is used to establish
+ * directionality:  to determine the directionality of the start
+ * point of a zero-length path segment, go backwards in the path
+ * data specification within the current subpath until you find a
+ * segment which has directionality at its end point (e.g., a path
+ * segment with non-zero length) and use its ending direction;
+ * otherwise, temporarily consider the start point to lack
+ * directionality. Similarly, to determine the directionality of the
+ * end point of a zero-length path segment, go forwards in the path
+ * data specification within the current subpath until you find a
+ * segment which has directionality at its start point (e.g., a path
+ * segment with non-zero length) and use its starting direction;
+ * otherwise, temporarily consider the end point to lack
+ * directionality. If the start point has directionality but the end
+ * point doesn't, then the end point uses the start point's
+ * directionality. If the end point has directionality but the start
+ * point doesn't, then the start point uses the end point's
+ * directionality. Otherwise, set the directionality for the path
+ * segment's start and end points to align with the positive x-axis
+ * in user space.
+ */
+static gboolean
+find_incoming_directionality_backwards (Segment *segments, int num_segments, int start_index, double *vx, double *vy)
+{
+    int j;
+    gboolean found;
+
+    /* "go backwards ... within the current subpath until ... segment which has directionality at its end point" */
+
+    found = FALSE;
+
+    for (j = start_index; j >= 0; j--) {
+        if (segments[j].is_degenerate)
+            break; /* reached the beginning of the subpath as we ran into a standalone point */
+        else {
+            if (is_zero_length_segment (&segments[j]))
+                continue;
+            else {
+                found = TRUE;
+                break;
+            }
+        }
+    }
+
+    if (found) {
+        g_assert (j >= 0);
+        *vx = segments[j].p4x - segments[j].p3x;
+        *vy = segments[j].p4y - segments[j].p3y;
+        return TRUE;
+    } else {
+        *vx = 0.0;
+        *vy = 0.0;
+        return FALSE;
+    }
+}
+
+static gboolean
+find_outgoing_directionality_forwards (Segment *segments, int num_segments, int start_index, double *vx, double *vy)
+{
+    int j;
+    gboolean found;
+
+    /* "go forwards ... within the current subpath until ... segment which has directionality at its start point" */
+
+    found = FALSE;
+
+    for (j = start_index; j < num_segments; j++) {
+        if (segments[j].is_degenerate)
+            break; /* reached the end of a subpath as we ran into a standalone point */
+        else {
+            if (is_zero_length_segment (&segments[j]))
+                continue;
+            else {
+                found = TRUE;
+                break;
+            }
+        }
+    }
+
+    if (found) {
+        g_assert (j < num_segments);
+        *vx = segments[j].p2x - segments[j].p1x;
+        *vy = segments[j].p2y - segments[j].p1y;
+        return TRUE;
+    } else {
+        *vx = 0.0;
+        *vy = 0.0;
+        return FALSE;
+    }
+}
+
+static double
+angle_from_vector (double vx, double vy)
+{
+    double angle;
+
+    angle = atan2 (vy, vx);
+
+    if (isnan (angle))
+        return 0.0;
+    else
+        return angle;
+}
+
+typedef enum {
+    NO_SUBPATH,
+    IN_SUBPATH,
+} SubpathState;
+
 void
-rsvg_render_markers (const RsvgBpathDef * bpath_def, RsvgDrawingCtx * ctx)
+rsvg_render_markers (RsvgDrawingCtx * ctx,
+                     const cairo_path_t *path)
 {
+    RsvgState *state;
+    double linewidth;
+    const char *startmarker;
+    const char *middlemarker;
+    const char *endmarker;
+
     int i;
+    double incoming_vx, incoming_vy;
+    double outgoing_vx, outgoing_vy;
 
-    double x, y;
-    double lastx, lasty;
-    double nextx, nexty;
-    double linewidth;
-    RsvgPathcode code, lastcode, nextcode;
+    Segment *segments;
+    int num_segments;
 
-    RsvgState *state;
-    RsvgMarker *startmarker;
-    RsvgMarker *middlemarker;
-    RsvgMarker *endmarker;
+    SubpathState subpath_state;
 
-    state = rsvg_state_current (ctx);
+    state = rsvg_current_state (ctx);
 
     linewidth = _rsvg_css_normalize_length (&state->stroke_width, ctx, 'o');
-    startmarker = (RsvgMarker *) state->startMarker;
-    middlemarker = (RsvgMarker *) state->middleMarker;
-    endmarker = (RsvgMarker *) state->endMarker;
+    startmarker = state->startMarker;
+    middlemarker = state->middleMarker;
+    endmarker = state->endMarker;
+
+    if (linewidth == 0)
+        return;
 
     if (!startmarker && !middlemarker && !endmarker)
         return;
 
-    x = 0;
-    y = 0;
-    code = RSVG_END;
-    nextx = bpath_def->bpath[0].x3;
-    nexty = bpath_def->bpath[0].y3;
-    nextcode = bpath_def->bpath[0].code;
-
-    for (i = 0; i < bpath_def->n_bpath - 1; i++) {
-        lastx = x;
-        lasty = y;
-	lastcode = code;
-        x = nextx;
-        y = nexty;
-	code = nextcode;
-        nextx = bpath_def->bpath[i + 1].x3;
-        nexty = bpath_def->bpath[i + 1].y3;
-	nextcode = bpath_def->bpath[i + 1].code;
-
-        if (nextcode == RSVG_MOVETO 
-	    || nextcode == RSVG_MOVETO_OPEN 
-	    || nextcode == RSVG_END) {
-            if (endmarker) {
-		if (code == RSVG_CURVETO) 
-		    rsvg_marker_render (endmarker, x, y, 
-					atan2 (y - bpath_def->bpath[i].y2, 
-					       x - bpath_def->bpath[i].x2), 
-					linewidth, ctx);
-		else
-		    rsvg_marker_render (endmarker, x, y, atan2 (y - lasty, x - lastx), linewidth, ctx);
-	    }
-        } else if (code == RSVG_MOVETO
-                   || code == RSVG_MOVETO_OPEN) {
-            if (startmarker) {
-		if (nextcode == RSVG_CURVETO)
-		    rsvg_marker_render (startmarker, x, y, 
-					atan2 (bpath_def->bpath[i + 1].y1 - y, 
-					       bpath_def->bpath[i + 1].x1 - x), linewidth,
-					ctx);
-		else 
-		    rsvg_marker_render (startmarker, x, y, atan2 (nexty - y, nextx - x), linewidth,
-					ctx);
-	    }
-	} else {
-	    if (middlemarker) {
-		double xdifin, ydifin, xdifout, ydifout, intot, outtot, angle;
-
-		if (code == RSVG_CURVETO) {
-		    xdifin = x - bpath_def->bpath[i].x2;
-		    ydifin = y - bpath_def->bpath[i].y2;
-		} else {
-		    xdifin = x - lastx;
-		    ydifin = y - lasty;
-		}
-		if (nextcode == RSVG_CURVETO) {
-		    xdifout = bpath_def->bpath[i+1].x1 - x;
-		    ydifout = bpath_def->bpath[i+1].y1 - y;
-		} else {
-		    xdifout = nextx - x;
-		    ydifout = nexty - y;
-		}
-
-		intot = sqrt (xdifin * xdifin + ydifin * ydifin);
-		outtot = sqrt (xdifout * xdifout + ydifout * ydifout);
-
-                xdifin /= intot;
-                ydifin /= intot;
-                xdifout /= outtot;
-                ydifout /= outtot;
-
-                angle = atan2 ((ydifin + ydifout) / 2, (xdifin + xdifout) / 2);
-                rsvg_marker_render (middlemarker, x, y, angle, linewidth, ctx);
+    if (path->num_data <= 0)
+        return;
+
+    /* Convert the path to a list of segments and bare points (i.e. degenerate segments) */
+    path_to_segments (path, &segments, &num_segments);
+
+    subpath_state = NO_SUBPATH;
+
+    for (i = 0; i < num_segments; i++) {
+        incoming_vx = incoming_vy = outgoing_vx = outgoing_vy = 0.0;
+
+        if (segments[i].is_degenerate) {
+            if (subpath_state == IN_SUBPATH) {
+                g_assert (i > 0);
+
+                /* Got a lone point after a subpath; render the subpath's end marker first */
+
+                find_incoming_directionality_backwards (segments, num_segments, i - 1, &incoming_vx, &incoming_vy);
+                rsvg_marker_render (endmarker, segments[i - 1].p4x, segments[i - 1].p4y, angle_from_vector (incoming_vx, incoming_vy), linewidth, ctx);
+            }
+
+            /* Render marker for the lone point; no directionality */
+            rsvg_marker_render (middlemarker, segments[i].p1x, segments[i].p1y, 0.0, linewidth, ctx);
+
+            subpath_state = NO_SUBPATH;
+        } else {
+            /* Not a degenerate segment */
+
+            if (subpath_state == NO_SUBPATH) {
+                find_outgoing_directionality_forwards (segments, num_segments, i, &outgoing_vx, &outgoing_vy);
+                rsvg_marker_render (startmarker, segments[i].p1x, segments[i].p1y, angle_from_vector (outgoing_vx, outgoing_vy), linewidth, ctx);
+
+                subpath_state = IN_SUBPATH;
+            } else {
+                /* subpath_state == IN_SUBPATH */
+
+                gboolean has_incoming, has_outgoing;
+                double incoming, outgoing;
+                double angle;
+
+                g_assert (i > 0);
+
+                has_incoming = find_incoming_directionality_backwards (segments, num_segments, i - 1, &incoming_vx, &incoming_vy);
+                has_outgoing = find_outgoing_directionality_forwards (segments, num_segments, i, &outgoing_vx, &outgoing_vy);
+
+                if (has_incoming)
+                    incoming = angle_from_vector (incoming_vx, incoming_vy);
+
+                if (has_outgoing)
+                    outgoing = angle_from_vector (outgoing_vx, outgoing_vy);
+
+                if (has_incoming && has_outgoing)
+                    angle = (incoming + outgoing) / 2;
+                else if (has_incoming)
+                    angle = incoming;
+                else if (has_outgoing)
+                    angle = outgoing;
+                else
+                    angle = 0.0;
+
+                rsvg_marker_render (middlemarker, segments[i].p1x, segments[i].p1y, angle, linewidth, ctx);
             }
         }
     }
+
+    /* Finally, render the last point */
+
+    if (num_segments > 0) {
+        if (!segments[num_segments - 1].is_degenerate) {
+            find_incoming_directionality_backwards (segments, num_segments, num_segments - 1, &incoming_vx, &incoming_vy);
+
+            rsvg_marker_render (endmarker, segments[num_segments - 1].p4x, segments[num_segments - 1].p4y, angle_from_vector (incoming_vx, incoming_vy), linewidth, ctx);
+        }
+    }
+
+    g_free (segments);
 }
diff --git a/rsvg-marker.h b/rsvg-marker.h
index 39817ee..e4e6726 100644
--- a/rsvg-marker.h
+++ b/rsvg-marker.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-marker.h: Marker loading and rendering
 
@@ -41,11 +42,10 @@ struct _RsvgMarker {
     RsvgViewBox vbox;
 };
 
+G_GNUC_INTERNAL
 RsvgNode    *rsvg_new_marker	    (void);
-void	     rsvg_marker_render	    (RsvgMarker * self, gdouble x, gdouble y, 
-				     gdouble orient, gdouble linewidth, RsvgDrawingCtx * ctx);
-RsvgNode    *rsvg_marker_parse	    (const RsvgDefs * defs, const char *str);
-void	     rsvg_render_markers    (const RsvgBpathDef * bpath_def, RsvgDrawingCtx * ctx);
+G_GNUC_INTERNAL
+void	     rsvg_render_markers    (RsvgDrawingCtx *ctx, const cairo_path_t *path);
 
 G_END_DECLS
 
diff --git a/rsvg-mask.c b/rsvg-mask.c
index db58580..44dd100 100644
--- a/rsvg-mask.c
+++ b/rsvg-mask.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /* 
    rsvg-filter.c: Provides filters
  
@@ -73,7 +74,7 @@ rsvg_new_mask (void)
     RsvgMask *mask;
 
     mask = g_new (RsvgMask, 1);
-    _rsvg_node_init (&mask->super);
+    _rsvg_node_init (&mask->super, RSVG_NODE_TYPE_MASK);
     mask->maskunits = objectBoundingBox;
     mask->contentunits = userSpaceOnUse;
     mask->x = _rsvg_css_parse_length ("0");
@@ -101,40 +102,6 @@ rsvg_get_url_string (const char *str)
     return NULL;
 }
 
-RsvgNode *
-rsvg_mask_parse (const RsvgDefs * defs, const char *str)
-{
-    char *name;
-
-    name = rsvg_get_url_string (str);
-    if (name) {
-        RsvgNode *val;
-        val = rsvg_defs_lookup (defs, name);
-        g_free (name);
-
-        if (val && (!strcmp (val->type->str, "mask")))
-            return val;
-    }
-    return NULL;
-}
-
-RsvgNode *
-rsvg_clip_path_parse (const RsvgDefs * defs, const char *str)
-{
-    char *name;
-
-    name = rsvg_get_url_string (str);
-    if (name) {
-        RsvgNode *val;
-        val = rsvg_defs_lookup (defs, name);
-        g_free (name);
-
-        if (val && (!strcmp (val->type->str, "clipPath")))
-            return val;
-    }
-    return NULL;
-}
-
 static void
 rsvg_clip_path_set_atts (RsvgNode * self, RsvgHandle * ctx, RsvgPropertyBag * atts)
 {
@@ -167,7 +134,7 @@ rsvg_new_clip_path (void)
     RsvgClipPath *clip_path;
 
     clip_path = g_new (RsvgClipPath, 1);
-    _rsvg_node_init (&clip_path->super);
+    _rsvg_node_init (&clip_path->super, RSVG_NODE_TYPE_CLIP_PATH);
     clip_path->units = userSpaceOnUse;
     clip_path->super.set_atts = rsvg_clip_path_set_atts;
     clip_path->super.free = _rsvg_node_free;
diff --git a/rsvg-mask.h b/rsvg-mask.h
index db225b3..bb6e4e2 100644
--- a/rsvg-mask.h
+++ b/rsvg-mask.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-mask.h : Provides Masks
 
@@ -45,8 +46,8 @@ struct _RsvgMask {
     RsvgMaskUnits contentunits;
 };
 
+G_GNUC_INTERNAL
 RsvgNode *rsvg_new_mask	    (void);
-RsvgNode *rsvg_mask_parse   (const RsvgDefs * defs, const char *str);
 
 typedef struct _RsvgClipPath RsvgClipPath;
 
@@ -55,8 +56,8 @@ struct _RsvgClipPath {
     RsvgCoordUnits units;
 };
 
+G_GNUC_INTERNAL
 RsvgNode *rsvg_new_clip_path	(void);
-RsvgNode *rsvg_clip_path_parse	(const RsvgDefs * defs, const char *str);
 
 G_END_DECLS
 #endif
